<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - proyecto/transactions_estimator.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">proyecto</a> - transactions_estimator.vhd<span style="font-size: 80%;"> (source / <a href="transactions_estimator.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">28</td>
            <td class="headerCovTableEntry">33</td>
            <td class="headerCovTableEntryMed">84.8 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 17:19:34</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">7</td>
            <td class="headerCovTableEntry">10</td>
            <td class="headerCovTableEntryLo">70.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">         16 : library ieee;</span></a>
<a name="2"><span class="lineNum">       2 </span>            : use ieee.std_logic_1164.all;</a>
<a name="3"><span class="lineNum">       3 </span>            : use ieee.numeric_std.all;</a>
<a name="4"><span class="lineNum">       4 </span>            : use ieee.math_real.all;</a>
<a name="5"><span class="lineNum">       5 </span>            : </a>
<a name="6"><span class="lineNum">       6 </span>            : library src_lib;</a>
<a name="7"><span class="lineNum">       7 </span>            : use src_lib.edc_common.all;</a>
<a name="8"><span class="lineNum">       8 </span>            : </a>
<a name="9"><span class="lineNum">       9 </span>            : library vunit_lib;</a>
<a name="10"><span class="lineNum">      10 </span>            : context vunit_lib.vunit_context;</a>
<a name="11"><span class="lineNum">      11 </span>            : context vunit_lib.com_context;</a>
<a name="12"><span class="lineNum">      12 </span>            : </a>
<a name="13"><span class="lineNum">      13 </span>            : library osvvm;</a>
<a name="14"><span class="lineNum">      14 </span>            : use osvvm.randompkg.all;</a>
<a name="15"><span class="lineNum">      15 </span>            : use osvvm.coveragepkg.all;</a>
<a name="16"><span class="lineNum">      16 </span>            : context osvvm.OsvvmContext;</a>
<a name="17"><span class="lineNum">      17 </span>            : </a>
<a name="18"><span class="lineNum">      18 </span>            : </a>
<a name="19"><span class="lineNum">      19 </span>            : package transactions_estimator is</a>
<a name="20"><span class="lineNum">      20 </span>            : </a>
<a name="21"><span class="lineNum">      21 </span>            :     type input_tran_t is record</a>
<a name="22"><span class="lineNum">      22 </span>            :         reset   : boolean;</a>
<a name="23"><span class="lineNum">      23 </span>            :         cycles  : integer;</a>
<a name="24"><span class="lineNum">      24 </span>            :         data_from_file : std_logic_vector(19 downto 0);</a>
<a name="25"><span class="lineNum">      25 </span>            :         data_from_file_valid : boolean;</a>
<a name="26"><span class="lineNum">      26 </span>            :         </a>
<a name="27"><span class="lineNum">      27 </span>            :       end record;</a>
<a name="28"><span class="lineNum">      28 </span>            :     </a>
<a name="29"><span class="lineNum">      29 </span>            :       type output_tran_t is record</a>
<a name="30"><span class="lineNum">      30 </span>            :         data_channel_output_re : signed(9 downto 0);</a>
<a name="31"><span class="lineNum">      31 </span>            :         data_channel_output_im : signed(9 downto 0);</a>
<a name="32"><span class="lineNum">      32 </span>            :         data_channel_output_valid : boolean;</a>
<a name="33"><span class="lineNum">      33 </span>            :       end record;</a>
<a name="34"><span class="lineNum">      34 </span>            : </a>
<a name="35"><span class="lineNum">      35 </span>            :         -- Message receivers, one for each entity that will receive transactions</a>
<a name="36"><span class="lineNum">      36 </span>            :         -- The checker has two receivers, so it can easily differentiate between</a>
<a name="37"><span class="lineNum">      37 </span>            :         -- actual and expected transactions</a>
<a name="38"><span class="lineNum">      38 </span><span class="lineCov">          2 :         constant driver_receiver : actor_t := new_actor(&quot;driver receiver&quot;);</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineCov">          2 :         constant predictor_receiver : actor_t := new_actor(&quot;predictor receiver&quot;);</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineCov">          2 :         constant checker_receiver_actual : actor_t := new_actor(&quot;checker receiver actual&quot;);</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineCov">          2 :         constant checker_receiver_expected : actor_t := new_actor(&quot;checker receiver expected&quot;);</span></a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            :         -- For functional coverage:</a>
<a name="44"><span class="lineNum">      44 </span><span class="lineCov">          2 :         constant coverage_receiver_input : actor_t := new_actor(&quot;coverage receiver input&quot;);</span></a>
<a name="45"><span class="lineNum">      45 </span><span class="lineCov">          2 :         constant coverage_receiver_output : actor_t := new_actor(&quot;coverage receiver output&quot;);</span></a>
<a name="46"><span class="lineNum">      46 </span>            : </a>
<a name="47"><span class="lineNum">      47 </span>            :         -- Objects for functional coverage</a>
<a name="48"><span class="lineNum">      48 </span><span class="lineCov">          2 :         signal cover_reset: CoverageIDtype := NewID(&quot;cover_reset&quot;);</span></a>
<a name="49"><span class="lineNum">      49 </span><span class="lineCov">          2 :         signal cover_enable: CoverageIDtype := NewID(&quot;cover_ena&quot;);</span></a>
<a name="50"><span class="lineNum">      50 </span><span class="lineCov">          2 :         signal cover_cycles: CoverageIDtype := NewID(&quot;cover_cycles&quot;);</span></a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">          2 :         signal cover_value: CoverageIDtype := NewID(&quot;cover_value&quot;);</span></a>
<a name="52"><span class="lineNum">      52 </span>            : </a>
<a name="53"><span class="lineNum">      53 </span>            :         -- Predefinition of functions and procedures in body</a>
<a name="54"><span class="lineNum">      54 </span>            :         procedure push(msg : msg_t; input_tran : input_tran_t);</a>
<a name="55"><span class="lineNum">      55 </span>            :         impure function pop(msg : msg_t) return input_tran_t;</a>
<a name="56"><span class="lineNum">      56 </span>            :         function to_string(input_tran : input_tran_t) return string;     </a>
<a name="57"><span class="lineNum">      57 </span>            :         procedure push(msg : msg_t; output_tran : output_tran_t);</a>
<a name="58"><span class="lineNum">      58 </span>            :         impure function pop(msg : msg_t) return output_tran_t;</a>
<a name="59"><span class="lineNum">      59 </span>            :         function to_string(output_tran : output_tran_t) return string;</a>
<a name="60"><span class="lineNum">      60 </span>            : </a>
<a name="61"><span class="lineNum">      61 </span>            :     </a>
<a name="62"><span class="lineNum">      62 </span>            : end package;</a>
<a name="63"><span class="lineNum">      63 </span>            : </a>
<a name="64"><span class="lineNum">      64 </span>            : </a>
<a name="65"><span class="lineNum">      65 </span>            : </a>
<a name="66"><span class="lineNum">      66 </span>            : package body transactions_estimator is</a>
<a name="67"><span class="lineNum">      67 </span>            : </a>
<a name="68"><span class="lineNum">      68 </span>            :      -- Since VUnit's communication library only allows to push and pop simple</a>
<a name="69"><span class="lineNum">      69 </span>            :   -- datatypes, we'll define our own procedures to push and pop complete</a>
<a name="70"><span class="lineNum">      70 </span>            :   -- transactions, using the already-defined push and pop procedures</a>
<a name="71"><span class="lineNum">      71 </span>            :   -- We will also define our own to_string() functions for debugging purposes</a>
<a name="72"><span class="lineNum">      72 </span><span class="lineCov">         20 :   procedure push(msg: msg_t; input_tran: input_tran_t) is</span></a>
<a name="73"><span class="lineNum">      73 </span>            :   begin</a>
<a name="74"><span class="lineNum">      74 </span><span class="lineCov">          4 :     push(msg, input_tran.reset);</span></a>
<a name="75"><span class="lineNum">      75 </span><span class="lineCov">          4 :     push(msg, input_tran.cycles);</span></a>
<a name="76"><span class="lineNum">      76 </span><span class="lineCov">          4 :     push(msg, input_tran.data_from_file);</span></a>
<a name="77"><span class="lineNum">      77 </span><span class="lineCov">         20 :     push(msg, input_tran.data_from_file_valid);</span></a>
<a name="78"><span class="lineNum">      78 </span>            :     </a>
<a name="79"><span class="lineNum">      79 </span>            :   end procedure;</a>
<a name="80"><span class="lineNum">      80 </span>            : </a>
<a name="81"><span class="lineNum">      81 </span>            :   -- Impure functions can read and write out of their scope, they have</a>
<a name="82"><span class="lineNum">      82 </span>            :   -- 'side effects'. Our 'pop' must be impure since it calls VUnit's 'pop'</a>
<a name="83"><span class="lineNum">      83 </span>            :   -- functions, which are impure themselves</a>
<a name="84"><span class="lineNum">      84 </span>            :   impure function pop(msg: msg_t) return input_tran_t is</a>
<a name="85"><span class="lineNum">      85 </span><span class="lineCov">         42 :     variable input_tran : input_tran_t;</span></a>
<a name="86"><span class="lineNum">      86 </span>            :   begin</a>
<a name="87"><span class="lineNum">      87 </span><span class="lineCov">          2 :     input_tran.reset  := pop(msg);</span></a>
<a name="88"><span class="lineNum">      88 </span><span class="lineCov">          2 :     input_tran.cycles := pop(msg);</span></a>
<a name="89"><span class="lineNum">      89 </span><span class="lineCov">          2 :     input_tran.data_from_file := pop(msg);</span></a>
<a name="90"><span class="lineNum">      90 </span><span class="lineCov">          2 :     input_tran.data_from_file_valid := pop(msg);</span></a>
<a name="91"><span class="lineNum">      91 </span><span class="lineCov">          2 :     return input_tran;</span></a>
<a name="92"><span class="lineNum">      92 </span>            :   end function;</a>
<a name="93"><span class="lineNum">      93 </span>            : </a>
<a name="94"><span class="lineNum">      94 </span>            :   function to_string(input_tran: input_tran_t) return string is</a>
<a name="95"><span class="lineNum">      95 </span>            :   begin</a>
<a name="96"><span class="lineNum">      96 </span><span class="lineCov">          4 :     return &quot;[input_tran] (reset =&gt; &quot; &amp; to_string(input_tran.reset) &amp;  &quot;, cycles =&gt; &quot; &amp; to_string(input_tran.cycles) &amp; &quot;)&quot;; </span></a>
<a name="97"><span class="lineNum">      97 </span>            :   end function;</a>
<a name="98"><span class="lineNum">      98 </span>            : </a>
<a name="99"><span class="lineNum">      99 </span><span class="lineCov">         16 :   procedure push(msg: msg_t; output_tran: output_tran_t) is</span></a>
<a name="100"><span class="lineNum">     100 </span>            :   begin</a>
<a name="101"><span class="lineNum">     101 </span><span class="lineCov">          4 :     push(msg, output_tran.data_channel_output_re);</span></a>
<a name="102"><span class="lineNum">     102 </span><span class="lineCov">          4 :     push(msg, output_tran.data_channel_output_im);</span></a>
<a name="103"><span class="lineNum">     103 </span><span class="lineCov">         16 :     push(msg, output_tran.data_channel_output_valid);</span></a>
<a name="104"><span class="lineNum">     104 </span>            :   end procedure;</a>
<a name="105"><span class="lineNum">     105 </span>            : </a>
<a name="106"><span class="lineNum">     106 </span>            :   impure function pop(msg: msg_t) return output_tran_t is</a>
<a name="107"><span class="lineNum">     107 </span><span class="lineNoCov">          0 :     variable output_tran : output_tran_t;</span></a>
<a name="108"><span class="lineNum">     108 </span>            :   begin</a>
<a name="109"><span class="lineNum">     109 </span><span class="lineNoCov">          0 :     output_tran.data_channel_output_re := pop(msg);</span></a>
<a name="110"><span class="lineNum">     110 </span><span class="lineNoCov">          0 :     output_tran.data_channel_output_im := pop(msg);</span></a>
<a name="111"><span class="lineNum">     111 </span><span class="lineNoCov">          0 :     output_tran.data_channel_output_valid := pop(msg);</span></a>
<a name="112"><span class="lineNum">     112 </span><span class="lineNoCov">          0 :     return output_tran;</span></a>
<a name="113"><span class="lineNum">     113 </span>            :   end function;</a>
<a name="114"><span class="lineNum">     114 </span>            : </a>
<a name="115"><span class="lineNum">     115 </span>            :   function to_string(output_tran: output_tran_t) return string is</a>
<a name="116"><span class="lineNum">     116 </span>            :   begin</a>
<a name="117"><span class="lineNum">     117 </span><span class="lineCov">          4 :     return &quot;[output_tran] (value =&gt; &quot; &amp;  &quot;)&quot;;</span></a>
<a name="118"><span class="lineNum">     118 </span>            :   end function;</a>
<a name="119"><span class="lineNum">     119 </span>            : </a>
<a name="120"><span class="lineNum">     120 </span>            :     </a>
<a name="121"><span class="lineNum">     121 </span>            : end package body;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
